    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %                                                               %
    %     prof.cls          encodage : utf8                         %
    %                                                               %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %                                                               %
    %           Créé par Alain Matthes le 12-06-2006.               %
    %                                                               %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Objet :  Classe LaTeX  et Styles pour des « textes mathématiques ».


% ===========================================================================

%% \CharacterTable
%%  {Upper-case    \A\B\C\D\E\F\G\H\I\J\K\L\M\N\O\P\Q\R\S\T\U\V\W\X\Y\Z
%%   Lower-case    \a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u\v\w\x\y\z
%%   Digits        \0\1\2\3\4\5\6\7\8\9
%%   Exclamation   \!     Double quote  \"     Hash (number) \#
%%   Dollar        \$     Percent       \%     Ampersand     \&
%%   Acute accent  \'     Left paren    \(     Right paren   \)
%%   Asterisk      \*     Plus          \+     Comma         \,
%%   Minus         \-     Point         \.     Solidus       \/
%%   Colon         \:     Semicolon     \;     Less than     \<
%%   Equals        \=     Greater than  \>     Question mark \?
%%   Commercial at \@     Left bracket  \[     Backslash     \\
%%   Right bracket \]     Circumflex    \^     Underscore    \_
%%   Grave accent  \`     Left brace    \{     Vertical bar  \|
%%   Right brace   \}     Tilde         \~}
 
% =========================================== Définitions relatives au package

\newcommand*{\PackageName}{prof}
\newcommand*{\PackageVersion}{0.9}
\newcommand*{\filedate}{25/09/06}

% ======================================================== Identification Part

\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{\PackageName}%
[\filedate \space Version:\space \PackageVersion \space par Alain Matthes ]

% ===================================================== Packages obligatoires

\RequirePackage{etex}
%\RequirePackage{xkeyval}
\RequirePackage{ifthen}
\RequirePackage{ifpdf} 
\RequirePackage{fancyhdr}
% ======================================================== Variables d'options

% Cette classe est basée sur la classe article. 
% Quelques options de la classe article sont utilisées.

% ====================================================== Options personnelles 

% nodate        : pas de date dans l'entête.
% nopage        : pas de numéros de page dans l'entête.
% landscape     : mode paysage.
% nostyle       : style article pour les listes.

\newif\if@cmr\@cmrfalse
\newif\if@lm\@lmfalse
\newif\if@oneside\@onesidetrue
\newif\if@twoside\@twosidefalse
\newif\if@nodate\@nodatefalse
\newif\if@nopage\@nopagefalse
\newif\if@landscape\@landscapefalse
\newif\if@bbpage\@bbpagefalse
\newif\if@nostyle\@nostylefalse

\newif\if@dvi\@dvifalse
\newcommand*{\my@encoding}{utf8}

\DeclareOption{a4paper}{%
\setlength\paperheight{297mm}\setlength\paperwidth{210mm}}%a4 obligatoire
\DeclareOption{oneside}{\@onesidetrue\@twosidefalse\@mparswitchfalse}
\DeclareOption{twoside}{\@onesidefalse\@twosidetrue\@mparswitchtrue}
\DeclareOption{nodate}{\@nodatetrue}

\DeclareOption{nopage}{\@nopagetrue}

\DeclareOption{lm}{\@lmtrue}
\DeclareOption{cmr}{\@cmrtrue\@lmfalse} 
\DeclareOption{fourier}{\@lmfalse\@cmrfalse}
\DeclareOption{draft}{\setlength\overfullrule{5pt}}
\DeclareOption{final}{\setlength\overfullrule{0pt}}
\DeclareOption{bbpage}{\@bbpagetrue}

\DeclareOption{applemac}{\renewcommand*{\my@encoding}{applemac}}
\DeclareOption{latin1}{\renewcommand*{\my@encoding}{latin1}}
\DeclareOption{utf8}{\renewcommand*{\my@encoding}{utf8}}
\DeclareOption{dvi}{\@dvitrue}
\DeclareOption{nostyle}{@nostyletrue}
\DeclareOption{landscape}{%
    \setlength\@tempdima{\paperheight}%
    \setlength\paperheight{\paperwidth}%
    \setlength\paperwidth{\@tempdima}
    \@landscapetrue}%

% Options de la classe article non autorisées.

\newcommand*{\@superflu}[1]
    {Option "\CurrentOption" superflue pour cette classe.}
\newcommand*{\@nonvalable}[1]
    {Option "\CurrentOption" non valable pour cette classe.}

\DeclareOption{10pt}        {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{a4paper}     {\ClassWarning{prof}{\@superflu}}
\DeclareOption{11pt}        {\ClassWarning{prof}{\@superflu}}
\DeclareOption{12pt}        {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{letterpaper} {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{legalpaper}  {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{a5paper}     {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{b5paper}     {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{onecolumn}   {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{twocolumn}   {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{titlepage}   {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{notitlepage} {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{fleqn}       {\ClassWarning{prof}{\@nonvalable}}
\DeclareOption{leqno}       {\ClassWarning{prof}{\@nonvalable}}

% ======================================================== Options par défaut

% a4
% 11pt
% utf8 
% oneside
% fourier with upright
% date 
% time
% page



% =================================================== Éxécution et chargement

\ExecuteOptions{oneside}
\ProcessOptions\relax

\if@oneside \typeout{oneside used} \else \typeout{oneside not used} \fi
\if@twoside \typeout{twoside used} \else \typeout{twoside not used} \fi

\if@dvi \typeout{pdflatex + pstricks used} \else \typeout{only pdflatex used} \fi


%\ifpdf \typeout{pdflatex} \else \typeout{latex} \fi
% =================================================== Chargement des Packages


% ==================================================================== Format

\newcommand*{\@proftextwidthhoriz}{24cm}
\newcommand*{\@proftextwidthvert}{16cm}
\newcommand*{\@profheadheight}{25pt}
\newcommand*{\@proftop}{2cm}
\newcommand*{\@profbottom}{2cm} 
\newcommand*{\@profheadsep}{12pt} 
\newcommand*{\@proffootskip}{25pt} 

% ==========================================================  AtEndDocument 

\AtEndDocument{\label{LastPage}} % astuce  ref de la dernière page  

% ============================================================================
\newcommand*{\@auteur}{A. Matthes} 
\newcommand*{\@lycee}{Coll\`ege S\'evign\'e}
\newcommand*{\@discipline}{Math\'ematiques}
  
\InputIfFileExists{profparam.cfg}{\typeout{Local file profparam.cfg used}}{}
\if@landscape \PassOptionsToPackage{landscape,textwidth=\@proftextwidthhoriz}{geometry}%
\else%
\PassOptionsToPackage{textwidth=\@proftextwidthvert}{geometry} \fi%

\RequirePackage[%
     \ifpdf pdftex\else dvips\fi,
      a4paper,%
      top=\@proftop,%
      bottom=\@profbottom,%
      headheight=\@profheadheight,%
      headsep=\@profheadsep,%
      footskip=\@proffootskip%
              ]{geometry}%         


\InputIfFileExists{prof.cfg}{\typeout{Local file prof.cfg used}}{}
   \pagenumbering{arabic}   
% ============================================================ Fonts and Sizes

\@lowpenalty   51
\@medpenalty  151
\@highpenalty 301
\relpenalty=10000
\binoppenalty=10000
\renewcommand*\normalsize{%
    \@setfontsize\normalsize\@xipt{13.6}%
    \abovedisplayskip 11\p@ \@plus3\p@ \@minus6\p@
    \abovedisplayshortskip \z@ \@plus3\p@
    \belowdisplayshortskip 6.5\p@ \@plus3.5\p@ \@minus3\p@
    \belowdisplayskip \abovedisplayskip
    \let\@listi\@listI}

\normalsize

\newcommand*\small{%
\@setfontsize\small\@xpt\@xiipt
    \abovedisplayskip 10\p@ \@plus2\p@ \@minus5\p@
    \abovedisplayshortskip \z@ \@plus3\p@
    \belowdisplayshortskip 6\p@ \@plus3\p@ \@minus3\p@
  \def\@listi{\leftmargin\leftmargini
               \topsep 6\p@ \@plus2\p@ \@minus2\p@
               \parsep 3\p@ \@plus2\p@ \@minus\p@
               \itemsep \parsep
              }%
   \belowdisplayskip \abovedisplayskip
}

\newcommand*\footnotesize{%
   \@setfontsize\footnotesize\@viiipt{9.5}%
    \abovedisplayskip 6\p@ \@plus2\p@ \@minus4\p@
    \abovedisplayshortskip \z@ \@plus\p@
    \belowdisplayshortskip 3\p@ \@plus\p@ \@minus2\p@
   \def\@listi{\leftmargin\leftmargini
               \topsep 4\p@ \@plus2\p@ \@minus2\p@
               \parsep 2\p@ \@plus\p@ \@minus\p@
               \itemsep \parsep
              }%
   \belowdisplayskip \abovedisplayskip
}

\newcommand*\scriptsize{\@setfontsize\scriptsize\@viiipt{9.5}}
\newcommand*\tiny{\@setfontsize\tiny\@vipt\@viipt{8}}
\newcommand*\large{\@setfontsize\large\@xiipt{14.5}}
\newcommand*\Large{\@setfontsize\Large\@xivpt{18}}
\newcommand*\LARGE{\@setfontsize\LARGE\@xviipt{22}}
\newcommand*\huge{\@setfontsize\huge\@xxpt{25}}
\newcommand*\Huge{\@setfontsize\Huge\@xxvpt{30}}

% ==================================================== En-tête et pied de page

\def \not@defined {???}
\let \@class = \not@defined
\let \@typedev = \not@defined
\let \@temps = \not@defined

\newcommand*{\param}[3]%
    {\renewcommand*{\@class}{#1}%
     \renewcommand*{\@typedev}{#2}%
     \renewcommand*{\@temps}{#3}%
    }

\newcommand*{\quand}{%
    \ifcase\month
        \or janvier \or f\'evrier \or mars \or avril \or mai \or juin
        \or juillet \or ao\^ut \or septembre \or octobre \or novembre
        \or d\'ecembre
    \fi%
    \space 
    \number\year%
    }
% 
\pagestyle{fancy}
\fancyhf{}
% 
\renewcommand\headrulewidth{0.4pt}
\renewcommand\footrulewidth{0.4pt} 
\renewcommand\headrule{\vspace{8pt}\hrule\vspace{1pt}\hrule}
% 
\if@twoside%option twoside

% ==== twoside entêtes ====

\fancyhead[LE]{}
\fancyhead[CE]{\ifx\@class\@empty \else \@class \fi}
\fancyhead[RE]{}

\fancyhead[LO]{\@discipline \ \ifx\@typedev\@empty \else \@typedev \fi}
\fancyhead[CO]{\ifx\@class\@empty \else \@class \fi}
\fancyhead[RO]{%
    \if@nodate%
        \else
        \quand\ 
        \fi
 \ifx\@temps\@empty
%   
 \else
  Dur\'ee~:~\@temps
 \fi
}
% ==== twoside pieds ====

\fancyfoot[LE]{}
\fancyfoot[CE]{\@lycee}
\fancyfoot[LE]{%
    \if@nopage%
        \else
       {\textit{Page}\ \thepage}%
        \fi
    }
\fancyfoot[RE]{}

\fancyfoot[LO]{\textit{\@auteur}}
\fancyfoot[CO]{\@lycee}
\fancyfoot[RO]{%
\if@nopage%
    \else
    \textit{Page}\ \thepage%
    \fi
    }

 \else % option oneside

% ==== oneside entête ====

\lhead{\@discipline \ \ifx\@typedev\@empty \else \@typedev \fi}
\chead{\ifx\@class\@empty \else \@class \fi }
\rhead{
\if@nodate%
    \else
    \quand\ 
    \fi
 \ifx\@temps\@empty
%   
 \else
  Dur\'ee~:~\@temps
 \fi
}

% ==== oneside pied ====
\lfoot{\@auteur}
\cfoot{\@lycee}
\rfoot{\ifthenelse{\boolean{@nopage}}{}{\textit{Page}\ \thepage}}%
\fi
% 
% ================================= Numérotation des exercices et des parties
\newcommand\nlafterexo{\smallskip}  
\newcounter {exo}
\newcounter {part}[exo]

\def\thepart{\Alph{part}}

\setcounter{exo}{0}
\setcounter{part}{0}


\newcommand*{\@points}[1]{%
\ifthenelse%
{\equal{#1}{}}
{}
{\hfill\textsl{(#1 points)}}%
}

\newcommand\exo[2][]{%
\smallskip%
\vspace{1ex}\stepcounter{exo}%
{\textbf{Exercice \no}%
\makebox[1.5 em]{\hfil\textbf{\theexo .}}}%
#2\@points{#1}
\nlafterexo} 

\newcommand*\part[1][]{{\stepcounter{part}\textbf{Partie\ \thepart}\hspace{12pt}\textsl{#1}}} 

% ================================================================= All files

\newcounter{max}
\newcounter{number}

\newcommand*{\InputAllExercise}[3]{%
% #1 chemin & #2 theme & #3 nbre d'exos
\setcounter{max}{#3}
\stepcounter{max}% 
\setcounter{number}{1}%
\whiledo{\value{number}<\value{max}}{%
   \InputIfFileExists{#1#2_\thenumber}{\exo{}\nlafterexo}%
{\typeout{exercice #1#2_\thenumber\ absent.}}%
   \stepcounter{number}}%
}%

% #1 nbre de colonnes 1 ou 2 #2 chemin & #3 theme & #4 nbre d'exos
\newcommand*{\ttexos}[4]{%
\ifnum #1=\tw@%
\setlength\columnseprule{0.4pt}% 
\setlength\columnsep{10\p@}  
\begin{multicols}{2}%
    %\setcounter{unbalance}{10}%
    \InputAllExercise{#2}{#3}{#4}%
\end{multicols}
\else
    \InputAllExercise{#2}{#3}{#4}%
\fi%
}%

% =============================================================== Some files

\newcommand*{\InputExerciseList}[3]{%
% #1 chemin & #2 theme & #3 liste de numéros
    \@for \@mynumber :=#3 \do {%
      \InputIfFileExists{#1#2_\@mynumber}{\exo{}  }% si draft (\@mynumber)
            {\typeout{exercice #1#2_\@mynumber\ absent.}}%
    }%
}

% #1 nbre de colonnes 1 ou 2 #2 chemin & #3 theme & #4 liste de numéros
\newcommand*{\qlqexos}[4]{%
\ifnum #1=\tw@%
\setlength\columnseprule{0.4pt}%
\setlength\columnsep{10\p@}

\begin{multicols}{2}%
    %\setcounter{unbalance}{10}%
    \InputExerciseList{#2}{#3}{#4}%
\end{multicols}
\else
    \InputExerciseList{#2}{#3}{#4}%
\fi%
}%

%===================================================================== bbpage
%il faudrait tester l'installation de tikzpicture donc incomplet...
%\@ifpackageloaded{tikz.sty} {\typeout{tikz used}
\if@bbpage
\def \not@defined {???}
\let \@bbtitle = \not@defined
\let \@bbcoeff = \not@defined
\let \@bbsession = \not@defined
\let \@bbserie = \not@defined
\let \@bbchoix = \not@defined
\let \@bbattention = \not@defined
\let \@bbniv = \not@defined
\let \@bbtime = \not@defined 

\newcommand*{\bbtitle}[1]{\renewcommand*{\@bbtitle}{#1}}
\newcommand*{\bbcoefficient}[1]{\renewcommand*{\@bbcoeff}{#1}}
\newcommand*{\bbsession}[1]{\renewcommand*{\@bbsession}{#1}}
\newcommand*{\bbserie}[1]{\renewcommand*{\@bbserie}{#1}} 
\newcommand*{\bbchoix}[1]{\renewcommand*{\@bbchoix}{#1}} 
\newcommand*{\bbniv}[1]{\renewcommand*{\@bbniv}{#1}}
\newcommand*{\bbtime}[1]{\renewcommand*{\@bbtime}{#1}} 
\long\def\bbattention#1{\protected@xdef\@bbattention{#1}}


\InputIfFileExists{bbpage.cfg}{\typeout{Local file bbpage.cfg used}}{\typeout{Local file bbpage.cfg not found}}

\newcommand\makebbpage{%
\thispagestyle{empty}
\null\vfill
   \begin{center} 
    \begin{tikzpicture}
        \draw (0,8) node[color=black,draw,fill=black!20]%
        {\fontsize{40}{40}\selectfont {\upshape \@bbtitle }};
        \node[name=s,shape=rectangle,rotate=36,color=black!60]%
        {\fontsize{100}{100}\selectfont {\upshape  \@bbchoix}};
        \draw (0,6) node[color=black] {\Huge  \@bbniv};
        \draw (0,4) node[color=black] {\Huge  S\'ERIE \@bbserie};
        \draw (0,-3.5) node[color=black] {\Large SESSION \@bbsession};
        \draw (0,-5.5) node[color=black,draw,fill=black!20, text centered]%
        {\textbf{\large{Dur\'ee de l'\'epreuve : \@bbtime -- Coefficient : \@bbcoeff }}};
            \draw (0,-10) node[text width=12cm,text justified]{\@bbattention};
            \draw (0,-7) node[ text centered]%
            {\textbf{Ce sujet comporte \pageref{LastPage} pages num\'erot\'ees de 2 \`a \pageref{LastPage}}};

                \end{tikzpicture}
        \end{center} 
        \vfill
\newpage
}%fin de  makebbpage
\else \fi%
%} {\typeout{tikz not used}}
% ================================================== Modification des vecteurs

\renewcommand{\vec}[1]{\overrightarrow{\rule{0em}{1.2ex}#1\rule{0.15em}{0ex}}}

% ========================================================= Ligne séparatrice

\def\sep{\vspace{12pt}\hrule height 0.4pt width\textwidth \vspace{12pt}}

% ========================================= Figures, flottants et Tables.

\setlength\arraycolsep{5\p@}
\setlength\tabcolsep{6\p@}
\setlength\arrayrulewidth{.4\p@}
\setlength\doublerulesep{2\p@}
\setlength\tabbingsep{\labelsep}
\skip\@mpfootins = \skip\footins
\setlength\fboxsep{3\p@}
\setlength\fboxrule{.4\p@}
\renewcommand \theequation {\@arabic\c@equation}
\newcounter{figure}
\renewcommand \thefigure {\@arabic\c@figure}
\def\fps@figure{tbp}
\def\ftype@figure{1}
\def\ext@figure{lof}
\def\fnum@figure{\figurename\nobreakspace\thefigure}
\newenvironment{figure}
               {\@float{figure}}
               {\end@float}
\newenvironment{figure*}
               {\@dblfloat{figure}}
               {\end@dblfloat}
\newcounter{table}
\renewcommand\thetable{\@arabic\c@table}
\def\fps@table{tbp}
\def\ftype@table{2}
\def\ext@table{lot}
\def\fnum@table{\tablename\nobreakspace\thetable}
\newenvironment{table}
               {\@float{table}}
               {\end@float}
\newenvironment{table*}
               {\@dblfloat{table}}
               {\end@dblfloat}
\newlength\abovecaptionskip
\newlength\belowcaptionskip
\setlength\abovecaptionskip{10\p@}
\setlength\belowcaptionskip{0\p@}
\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  \sbox\@tempboxa{#1: #2}%
  \ifdim \wd\@tempboxa >\hsize
    #1: #2\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi
  \vskip\belowcaptionskip}




% ==========================================================  AtBeginDocument 
% incomplet   il faut commenter
\AtBeginDocument{%
\setlength{\parindent}{0 pt}
\setlength{\parskip}{6 pt}  
%traitement des listes
\renewcommand\labelitemiii  {\textasteriskbullet}
\renewcommand\labelitemi    {\textbullet}
\renewcommand\labelitemii   {\textasteriskcentered}
\newcommand{\labelenumi}    {\textbf{\arabic{enumi}.}}%
\newcommand{\labelenumii}   {\textbf{\alph{enumii}.}}%

\setlength\leftmargini {1em}
\leftmargin\leftmargini
\setlength\leftmarginii  {1.2em}
\setlength\leftmarginiii {0.8em}
\setlength\leftmarginiv  {0.8em}
 
\def\enumerate{%
   \ifnum \@enumdepth >3 \@toodeep
   \else
   \advance\@enumdepth \@ne
   \edef\@enumctr{enum\romannumeral\the\@enumdepth}
    \list{\csname label\@enumctr\endcsname}%
      {%
      \usecounter{\@enumctr}\parsep=0pt\leftmargin=13pt%
      \labelsep=2pt%
      \labelwidth=\leftmargin%
      \advance\labelwidth-\labelsep%
      \topsep=6pt plus2pt minus2pt
      \partopsep=0pt%
      \parsep=2pt plus1pt minus1pt%
      \itemsep=0pt
      \def\makelabel##1{\hbox to\labelwidth{##1\hss}}%
      }%
    \fi}

\def\itemize{%
    \ifnum \@itemdepth >3 \@toodeep
    \else
        \advance\@itemdepth \@ne
        \edef\@itemitem{labelitem\romannumeral\the\@itemdepth}
        \list{\csname \@itemitem\endcsname}%
        {%
        \parsep=0pt
        \leftmargin=10pt
        \labelsep=2pt
        \labelwidth=\leftmargin
        \advance\labelwidth-\labelsep
        \topsep=6pt plus2pt minus2pt
        \partopsep=0pt
        \itemsep=0pt
        \def\makelabel##1{\hbox to\labelwidth{##1\hss}}%
        }%
    \fi}
 \newenvironment{description}
               {\list{}{\labelwidth\z@ \itemindent-\leftmargin
                        \let\makelabel\descriptionlabel}}
               {\endlist}
\newcommand*\descriptionlabel[1]{\hspace\labelsep
                                \normalfont\bfseries #1}


\DecimalMathComma
\AddThinSpaceBeforeFootnotes
\NoAutoSpaceBeforeFDP
\frenchspacing
\FrenchListSpacingtrue
\FrenchItemizeSpacingtrue
\FrenchFootnotes 
 %\setstretch{1.2} 
\AddThinSpaceBeforeFootnotes% (« 1. Note »)
\ThinSpaceInFrenchNumbers% espace fine% 

\StandardLayout%   mise en page originale de LaTeX
\parskip5pt
}% fin de atbegindoc 


\endinput
% ============================================================================


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %                                                               %
    %          End of file `prof.cls'. v 0.1  03/07/2006            %
    %                                                               %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

